%{!?__python_ver:%define __python_ver EMPTY}
%define unicode ucs4

%if "%{__python_ver}" != "EMPTY"
%define main_python 0
%define python python%{__python_ver}
%else
%define main_python 1
%define python python
%endif

%define pybasever 2.4
%define jp_codecs 1.4.11
%define tools_dir %{_libdir}/python%{pybasever}/Tools
%define demo_dir %{_libdir}/python%{pybasever}/Demo

Summary:	An interpreted, interactive, object-oriented programming language.
Name:		python
Version:	%{pybasever}.1
Release:	2
License:	PSF - see LICENSE
Group:		Development/Languages
Source0:	http://www.python.org/ftp/python/%{version}/Python-%{version}.tar.bz2
Source3:	modulator
Source4:	pynche
Source5:	http://www.python.jp/pub/JapaneseCodecs/JapaneseCodecs-%{jp_codecs}.tar.gz
Source6:	http://gigue.peabody.jhu.edu/~mdboom/omi/source/shm_source/shmmodule.c
Source7:	python-2.3.4-optik.py

Patch0:		python-2.4.1-config.patch
Patch1:		Python-2.2.1-pydocnogui.patch
Patch2:		python-2.4-distutils-bdist-rpm.patch
Patch3:		python-2.3.4-pydocnodoc.patch
Patch10:	python-2.3.4-lib64-regex.patch
Patch11:	python-2.4.1-lib64.patch
Patch12:	japanese-codecs-lib64.patch
Patch20:	python-2.4.1-no-tkinter-gd-1.diff

BuildPrereq:	readline-devel, libtermcap-devel, openssl-devel, libgmp-devel
BuildPrereq:	ncurses-devel, gdbm-devel, zlib-devel, expat-devel
BuildPrereq:	gcc-c++ glibc-devel db4-devel >= 4.3
BuildPrereq:	bzip2 bzip2-devel tar /usr/bin/find pkgconfig
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Provides:	python-abi = %{pybasever}
Provides:	python(abi) = %{pybasever}
Provides:	python-optik = 1.4.1
Obsoletes:	python-optik

%description
Python is an interpreted, interactive, object-oriented programming
language often compared to Tcl, Perl, Scheme or Java. Python includes
modules, classes, exceptions, very high level dynamic data types and
dynamic typing. Python supports interfaces to many system calls and
libraries, as well as to various windowing systems (X11, Motif, Tk,
Mac and MFC).

Programmers can write new built-in modules for Python in C or C++.
Python can be used as an extension language for applications that need
a programmable interface. This package contains most of the standard
Python modules, as well as modules for interfacing to the Tix widget
set for Tk and RPM.

%files -f dynfiles
%defattr(-, root, root)
%doc LICENSE README
%{_bindir}/python*
%{_mandir}/*/*
%{_libdir}/libpython%{pybasever}.so*

%dir %{_libdir}/python%{pybasever}
%{_libdir}/python%{pybasever}/site-packages/japanese.pth
%dir %{_libdir}/python%{pybasever}/site-packages
%{_libdir}/python%{pybasever}/site-packages/japanese
%{_libdir}/python%{pybasever}/site-packages/README
%{_libdir}/python%{pybasever}/LICENSE.txt
%{_libdir}/python%{pybasever}/*.py*
%{_libdir}/python%{pybasever}/*.doc
%{_libdir}/python%{pybasever}/bsddb
%dir %{_libdir}/python%{pybasever}/config
%{_libdir}/python%{pybasever}/config/Makefile
%{_libdir}/python%{pybasever}/curses
%{_libdir}/python%{pybasever}/distutils
%{_libdir}/python%{pybasever}/encodings
%{_libdir}/python%{pybasever}/idlelib
%{_libdir}/python%{pybasever}/lib-old
%{_libdir}/python%{pybasever}/logging
%{_libdir}/python%{pybasever}/xml
%{_libdir}/python%{pybasever}/email
%{_libdir}/python%{pybasever}/compiler
%{_libdir}/python%{pybasever}/plat-linux2
%{_libdir}/python%{pybasever}/hotshot
%if %{_lib} == lib64
%attr(0755,root,root) %dir /usr/lib/python%{pybasever}
%attr(0755,root,root) %dir /usr/lib/python%{pybasever}/site-packages
%endif

%package devel
Summary:	The libraries and header files needed for Python development.
Group:		Development/Libraries
Requires:	%{python} = %{version}-%{release}
Conflicts:	%{python} < %{version}-%{release}

%description devel
The Python programming language's interpreter can be extended with
dynamically loaded extensions and can be embedded in other programs.
This package contains the header files and libraries needed to do
these types of tasks.

%files devel
%defattr(-,root,root)
/usr/include/*
%{_libdir}/python%{pybasever}/config
%{_libdir}/python%{pybasever}/test

%package tools
Summary:	A collection of development tools included with Python.
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}

%description tools
The Python package includes several development tools that are used
to build python programs.

%files tools
%defattr(-,root,root,755)
%doc Tools/modulator/README.modulator
%doc Tools/pynche/README.pynche
%{_libdir}/python%{pybasever}/site-packages/modulator
%{_libdir}/python%{pybasever}/site-packages/pynche
%{_bindir}/smtpd.py*
%{_bindir}/idle*
%{_bindir}/modulator*
%{_bindir}/pynche*
%{_bindir}/pygettext*.py*
%{_bindir}/msgfmt*.py*
%{_bindir}/pydoc*
%{tools_dir}
%{demo_dir}

%prep
%setup -q -n Python-%{version} -a 5

%patch0 -p1
%patch1 -p1
%if %{_lib} == lib64
%patch10 -p1
%patch11 -p1
%patch12 -p0
%endif
%patch2 -p1
%patch3 -p1
%patch20 -p1

# This shouldn't be necesarry, but is right now (2.2a3)
find -name "*~" |xargs rm -f

# Temporary workaround to avoid confusing find-requires: don't ship the tests
# as executable files
chmod 0644 Lib/test/test_*.py

# shm module
cp %{SOURCE6} Modules
cat >> Modules/Setup.dist << EOF

# Shared memory module
shm shmmodule.c
EOF

# Backwards compatible optik
install -m 0644 %{SOURCE7} Lib/optik.py

%build
  topdir=`pwd`
  export CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -fPIC"
  export CXXFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -fPIC"
  export OPT="$RPM_OPT_FLAGS -D_GNU_SOURCE -fPIC"
  export LINKCC="gcc"

  if pkg-config openssl ; then
	export CFLAGS="$CFLAGS `pkg-config --cflags openssl`"
	export LDFLAGS="$LDFLAGS `pkg-config --libs-only-L openssl`"
  fi

  export CC=gcc
  %configure --enable-ipv6 --enable-unicode=%{unicode} --enable-shared

  make OPT="$CFLAGS" %{?_smp_mflags}
  LD_LIBRARY_PATH=$topdir $topdir/python Tools/scripts/pathfix.py -i "%{_bindir}/env python%{pybasever}" .
  make OPT="$CFLAGS" %{?_smp_mflags}

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  install -d $RPM_BUILD_ROOT/%{_prefix}
  install -d $RPM_BUILD_ROOT%{_mandir}

  # Clean up patched .py files that are saved as .lib64
  for f in distutils/command/install distutils/sysconfig; do
    rm -f Lib/$f.py.lib64
  done

  make install DESTDIR=$RPM_BUILD_ROOT

  # Fix the interpreter path in binaries installed by distutils 
  # (which changes them by itself)
  # Make sure we preserve the file permissions
  for fixed in $RPM_BUILD_ROOT%{_bindir}/pydoc; do
    sed 's,#!.*/python$,#!%{_bindir}/env python%{pybasever},' $fixed > $fixed- \
        && cat $fixed- > $fixed && rm -f $fixed-
  done

  # tools
  mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/python%{pybasever}/site-packages

  # modulator
  install -m 755 $RPM_SOURCE_DIR/modulator ${RPM_BUILD_ROOT}%{_bindir}/modulator
  cp -r Tools/modulator ${RPM_BUILD_ROOT}%{_libdir}/python%{pybasever}/site-packages/

  # pynche
  install -m 755 $RPM_SOURCE_DIR/pynche ${RPM_BUILD_ROOT}%{_bindir}/pynche
  rm -f Tools/pynche/*.pyw
  cp -r Tools/pynche ${RPM_BUILD_ROOT}%{_libdir}/python%{pybasever}/site-packages/

  mv Tools/modulator/README Tools/modulator/README.modulator
  mv Tools/pynche/README Tools/pynche/README.pynche

  # gettext
  install -m755  Tools/i18n/pygettext.py $RPM_BUILD_ROOT%{_bindir}/
  install -m755  Tools/i18n/msgfmt.py $RPM_BUILD_ROOT%{_bindir}/

  # Useful development tools
  install -m755 -d $RPM_BUILD_ROOT%{tools_dir}/scripts
  install Tools/README $RPM_BUILD_ROOT%{tools_dir}/
  install Tools/scripts/*py $RPM_BUILD_ROOT%{tools_dir}/scripts/

  # Useful demo scripts
  install -m755 -d $RPM_BUILD_ROOT%{demo_dir}
  cp -ar Demo/* $RPM_BUILD_ROOT%{demo_dir}

  # Get rid of crap
  find $RPM_BUILD_ROOT/ -name "*~"|xargs rm -f
  find $RPM_BUILD_ROOT/ -name ".cvsignore"|xargs rm -f
  find . -name "*~"|xargs rm -f
  find . -name ".cvsignore"|xargs rm -f

  # zero length
  rm -f $RPM_BUILD_ROOT%{_libdir}/python%{pybasever}/site-packages/modulator/Templates/copyright

  # Clean up the testsuite - we don't need compiled files for it
  find $RPM_BUILD_ROOT%{_libdir}/python%{pybasever}/test \
    -name "*.pyc" -o -name "*.pyo" | xargs rm -f
  rm -f $RPM_BUILD_ROOT%{_libdir}/python2.2/LICENSE.txt

  # Japanese codecs
  pushd JapaneseCodecs-%{jp_codecs}
  # We need to set LD_LIBRARY_PATH since python is now compiled as shared, and
  # we always want to use the currently compiled one
  LD_LIBRARY_PATH=$RPM_BUILD_ROOT%{_libdir} ../python setup.py install --root=$RPM_BUILD_ROOT
  popd

  find $RPM_BUILD_ROOT%{_libdir}/python%{pybasever}/lib-dynload -type d | sed "s|$RPM_BUILD_ROOT|%dir |" > dynfiles
  find $RPM_BUILD_ROOT%{_libdir}/python%{pybasever}/lib-dynload -type f | grep -v "_tkinter.so$" | sed "s|$RPM_BUILD_ROOT||" >> dynfiles

  # Fix for bug #136654
  rm -f $RPM_BUILD_ROOT%{_libdir}/python%{pybasever}/email/test/data/audiotest.au

  # Fix bug #143667: python should own /usr/lib/python2.x on 64-bit machines
%if %{_lib} == lib64
  install -d $RPM_BUILD_ROOT/usr/lib/python%{pybasever}/site-packages
%endif

  # Remove unpackaged files.
  rm -fr $RPM_BUILD_ROOT/%{_libdir}/python%{pybasever}/lib-tk

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Sep 13 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.4.1, Release 2
  - Remove tkinter from the lib64 patches.

* Mon Sep 12 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.4.1, Release 1
  - Initial build for EnGarde Secure Linux.
  - SPEC still needs major cleanup.
